# Author:    Lisandro Dalcin
# Contact:   dalcinl@users.sourceforge.net
# Revision:  $Revision: 1.8 $
# Date:      $Date: 2006/08/02 17:22:36 $
# Copyright: This file has been placed in the public domain.

"""
MPI Operations.
"""

__author__    = 'Lisandro Dalcin'
__credits__   = 'MPI Forum, MPICH Team, LAM Team.'
__date__      = '02 Aug 2006'
__version__   = '0.3.1'
__revision__  = '$Id: _op.py,v 1.8 2006/08/02 17:22:36 dalcinl Exp $'

import operator as _operator

MAX  = max

MIN  = min

SUM  = _operator.add

PROD = _operator.mul

BAND = _operator.and_

BOR  = _operator.or_

BXOR = _operator.xor

def LAND(x, y):
    'logical and'
    return bool(x) & bool(y)

def LOR(x, y):
    'logical or'
    return bool(x) | bool(y)

def LXOR(x, y):
    'logical xor'
    return bool(x) ^ bool(y)

def MAXLOC(x, y):
    'maximum and location'
    u, i = x
    v, j = y
    w = max(u, v)
    if u == v:
        k = min(i, j)
    elif u <  v:
        k = j
    else:
        k = i
    return (w, k)

def MINLOC(x, y):
    'minimum and location'
    u, i = x
    v, j = y
    w = min(u, v)
    if u == v:
        k = min(i, j)
    elif u <  v:
        k = i
    else:
        k = j
    return (w, k)
