/* $Id: pickle.c,v 1.2 2006/06/18 03:18:05 dalcinl Exp $ */ 

#include <Python.h>

static PyObject* cPickle_dumps = NULL;
static PyObject* cPickle_loads = NULL;
static PyObject* cPickle_PROTO = NULL;

static PyObject* 
pickle_dump(PyObject* self, PyObject* args) {
  PyObject*  obj;
  if ( !PyArg_ParseTuple(args, "O", &obj) ) return NULL;
  return PyObject_CallFunctionObjArgs(cPickle_dumps,
				      obj, cPickle_PROTO, NULL);
}

static PyObject* 
pickle_load(PyObject* self, PyObject* args) {
  return PyObject_CallObject(cPickle_loads, args);
}

static struct PyMethodDef pickle_methods[] = {
  {"dump", pickle_dump, METH_VARARGS},
  {"load", pickle_load, METH_VARARGS},
  {NULL, NULL} /* Sentinel */
};

PyMODINIT_FUNC
init_pickle(void) {

  PyObject* m;

  m = Py_InitModule("_pickle", pickle_methods);
  if (m == NULL) return;

  m = PyImport_ImportModule("cPickle");
  if (m == NULL) return;
  
  cPickle_loads = PyObject_GetAttrString(m, "loads");
  if (cPickle_loads == NULL) return;
  cPickle_dumps = PyObject_GetAttrString(m, "dumps");
  if (cPickle_dumps == NULL) return;
  cPickle_PROTO = PyObject_GetAttrString(m, "HIGHEST_PROTOCOL");
  if (cPickle_PROTO == NULL) return;

  Py_DECREF(m);
}
